<?php

defined('BASEPATH') OR exit('No direct script access allowed');

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require_once APPPATH . '/libraries/REST_Controller.php';

/**
 * This is an example of a few basic user interaction methods you could use
 * all done with a hardcoded array
 *
 * @package         CodeIgniter
 * @subpackage      Rest Server
 * @category        Controller
 * @author          
 * @license         MIT
 * @link            
 */
class Login_Controller extends REST_Controller {
    function __construct()
    {
        // Construct the parent class
        parent::__construct();

        // Configure limits on our controller methods
        // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
        $this->methods['login_post']['limit'] = 10000; // 100 requests per hour per user/key
        $this->load->model('Login_model', 'login_model');
    }

   

    /**
     * Login API For All Level
     * VIT-sriram
     * 19/08/2019
     * Parms(username,password)
     */

    public function login_post()
    {   
		$records = $this->post('records');
		
        $loginDetails = $this->login_model->login($records);// Check if the users data store 

        if ($loginDetails['loginStatus'])
            {
                    $result = $loginDetails['result'];
                $tokenData = array();

                $type_name = $this->login_model->get_category($result->emis_usertype);
                $tokenData['emis_user_id']        = $result->emis_user_id;
                $tokenData['emis_username']       = $result->emis_username;
                $tokenData['emis_user_type_id']   = $result->emis_usertype;
                $tokenData['emis_brte_name']      = $result->brte_name;
                $tokenData['emis_user_type_name'] = $type_name->user_type;
                $tokenData['emis_user_type_id1']  = $result->emis_usertype1;
                $tokenData['emis_loggedin']       = $result->status;
                $tokenData['emis_district_id']    = $result->district_id;
                $tokenData['emis_district_name']  = $result->office_name;
                $tokenData['iat']                 = strtotime("now");
                $tokenData['exp']                 = strtotime("+30 days");
                //$tokenData['timestamp'] = strtotime("+2 hours");
                // print_r($tokenData);die;
                $output['token'] = AUTHORIZATION::generateToken($tokenData);
               // $generate=AUTHORIZATION::validateTimestamp($output['token']);
                        $data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['records'] = $output;
                        $this->response($data,REST_Controller::HTTP_OK);
            }
            else
            {
                        $data['dataStatus'] = false;
                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                        $data['message'] = $loginDetails['message'];
                        $this->response($data,REST_Controller::HTTP_OK);
            }
    }


    public function school_details_post()
    {


        $block_id = $this->post('block_id');
        // echo $block_id;die;
        $result = $this->observation_model->get_school_details($block_id);
        // print_r(json_encode($result));die;
        if(!empty($result))
        {
                        $data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['records'] = $result;
                        $this->response($data,REST_Controller::HTTP_OK);
        }else
        {
                        $data['dataStatus'] = false;
                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                        $data['message'] = 'No Data';
                        $this->response($data,REST_Controller::HTTP_NO_CONTENT);
        }

    }


    



}
 