<?php

defined('BASEPATH') OR exit('No direct script access allowed');

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require_once APPPATH . '/libraries/REST_Controller.php';
use Raulr\GooglePlayScraper\Scraper;
/**
 * This is an example of a few basic user interaction methods you could use
 * all done with a hardcoded array
 *
 * @package         CodeIgniter
 * @subpackage      Rest Server
 * @category        Controller
 * @author          
 * @license         MIT
 * @link            
 */
class School_Information_Controller extends REST_Controller {
    function __construct()
    {
        // Construct the parent class
        parent::__construct();

        $this->load->model('school_info/School_Information_model','school_information_model');
    }


    /**
      * School Information Details 
      * VIT-sriram
      * 10/10/2019
      * @parms school_id
      * Get Details In This API School Information Details,Class Section Details,
      * 
      */

    public function school_full_details_POST()
    {
      date_default_timezone_set('Asia/Kolkata');
    	$school_id   	= $this->post('school_id');
		$result['school_info'] 	= $this->school_information_model->get_school_details($school_id);
		$result['school_section'] = $this->school_information_model->get_school_section($school_id); 
    $result['date'] = date('Y-m-d h:i:s');
		// print_r($result);die;
		if($result['school_info'] !='')
		{
						$data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['records'] = $result;
                        $this->response($data,REST_Controller::HTTP_OK);
		}else
		{
			 			$data['dataStatus'] = false;
                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                        $data['message'] = 'No Data';
                        $this->response($data,REST_Controller::HTTP_OK);
		}

	}


	  /**
      * Studnets Information Details 
      * VIT-sriram
      * 10/10/2019
      * @parms school_id
      * Get Details In This API Students Class And Sectionwise Details
      * 
      */

	public function students_school_details_POST()
	{
			$school_id = $this->post('school_id');
      $class_id = $this->post('class_id');
			$result = $this->school_information_model->get_school_student_data($school_id,$class_id);
			if(!empty($result))
			{
						$data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['records'] = $result;
                        $this->response($data,REST_Controller::HTTP_OK);
			}else
			{
				 			$data['dataStatus'] = false;
	                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
	                        $data['message'] = 'No Data';
	                        $this->response($data,REST_Controller::HTTP_OK);
			}


	}


  /************************************* End ********************************/

    /**
      * Studnets Information Details 
      * VIT-sriram
      * 10/10/2019
      * @parms school_id
      * Get Details In This API Students Class And Sectionwise Details
      * 
      */

    public function schoolwise_teacher_list_POST()
    {
        $school_id = $this->post('school_id');

        $result['teachers_info'] = $this->school_information_model->get_schoolwise_teacher_list($school_id);
        $result['teacher_reason'] = $reason_arr = array(
                                                            array('id'=>'FC','name'=>'Full CL'),
                                                            array('id'=>'HC','name'=>'Half CL'),
                                                            array('id'=>'EL','name'=>'EL'),
                                                            array('id'=>'OD','name'=>'OD'),
                                                            array('id'=>'ML','name'=>'ML'),
                                                            array('id'=>'LO','name'=>'LOP'),
                                                            array('id'=>'UE','name'=>'UEL'),
                                                            array('id'=>'RH','name'=>'RH'),
                                                            array('id'=>'TR','name'=>'Training'),
                                                            array('id'=>'PT','name'=>'Part Time no-duty'),
                                                            array('id'=>'PL','name'=>'Maternity Leave'),
                                                            array('id'=>'UA','name'=>'UnAuthorized'),
                                                            array('id'=>'OT','name'=>'Others')
                                                            );
        $result['school_status'] = $this->school_information_model->get_marked_teacher_records_status($school_id);
        $result['date'] = date('Y-m-d');
        if(!empty($result))
        {
                        $data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['records'] = $result;
                        $this->response($data,REST_Controller::HTTP_OK);
        }else
        {
                        $data['dataStatus'] = false;
                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                        $data['message'] = 'No Data';
                        $this->response($data,REST_Controller::HTTP_OK);
        }
    }

    public function appInfo_get()
    {
        $result = $this->school_information_model->mbl_app_info();
        if($result !='')
        {
                        $data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['records'] = $result;
                        $this->response($data,REST_Controller::HTTP_OK);
        }else
        {
                        $data['dataStatus'] = false;
                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                        $data['message'] = 'No Data';
                        $this->response($data,REST_Controller::HTTP_OK);
        }
        
    }


    /**************************** End **************************************/

    /****************************** School Message / Notification **********/

    /**
      * Mobile Message Api
      * Sriram
      * 13/12/2019
      */

    public function schoolwise_mobile_message_get()
    {
      $school_id = $this->get('school_id');
      $result = $this->school_information_model->get_flash_news_data($school_id);
      if(!empty($result))
        {
                        $data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['records'] = $result;
                        $this->response($data,REST_Controller::HTTP_OK);
        }else
        {
                        $data['dataStatus'] = false;
                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                        $data['message'] = 'No Data';
                        $this->response($data,REST_Controller::HTTP_OK);
        }
    }

    public function voctnl_book_students_details_POST()
    {
        $school_id = $this->post('school_id');
        $class_id = $this->post('class_id');
        $sec = $this->post('section');
        $result = $this->school_information_model->voctnl_book_studntlist($school_id,$class_id,$sec);
        if(!empty($result))
        {
              $data['dataStatus'] = true;
                          $data['status'] = REST_Controller::HTTP_OK;
                          $data['records'] = $result;
                          $this->response($data,REST_Controller::HTTP_OK);
        }else
        {
                $data['dataStatus'] = false;
                            $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                            $data['message'] = 'No Data';
                            $this->response($data,REST_Controller::HTTP_OK);
        }


    }
}
?>