<?php

defined('BASEPATH') OR exit('No direct script access allowed');

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require_once APPPATH . '/libraries/REST_Controller.php';

/**
 * This is an example of a few basic user interaction methods you could use
 * all done with a hardcoded array
 *
 * @package         CodeIgniter
 * @subpackage      Rest Server
 * @category        Controller
 * @author          
 * @license         MIT
 * @link            
 */
class Teacher_Attendance_Controller extends REST_Controller {
    function __construct()
    {
        // Construct the parent class
        parent::__construct();
        date_default_timezone_set('Asia/Kolkata');
        $this->load->model('teacher/Teacher_Attendance_model','teacher_attendance_model');
    }



    /**
      * Save Teacher Attendance
      * sriram 
      * 04/12/2019
      **/

    public function save_teacher_attendance_post()
    {
    	$records = $this->post('records');
    	$school_id = $this->post('school_id');
    	$school_code = $this->post('school_code');
    	$sync_time = $this->post('appSyncTime');
    	// print_r($records);die;
    	$filterBy = 0;
		$notAvail = 2;
	    	$absent = array_filter($records, function ($var) use ($filterBy,$notAvail) {
					    return ($var['present'] == $filterBy || $var['present'] == $notAvail);
					});

	    	// print_r($absent);die;

	    	$save_data = [];
	    	if(!empty($absent))
	    	{
	    		$exits_teacher = $this->teacher_attendance_model->exits_attendance_details('teach_attendance_live',$school_id);	
	    		// print_r($exits_teacher);die;
	    		$result =[];
	    		foreach ($absent as $key => $value) 
	    		{
	    			// 
		    		$save_data['id'] = $value['id'];
		    		$save_data['teacher_name'] = $value['teacher_name'];
		    		$save_data['teacher_code'] = $value['u_id'];
		    		$save_data['school_id'] = $school_id;
		    		$save_data['date'] = date('Y-m-d');
		    		$save_data['attstatus'] = $value['attstatus'];
		    		$save_data['attres'] = $value['attres'];
		    		$save_data['atturl'] = 'Mobile';
		    		$save_data['school_code'] = $school_code;
		    		$save_data['mark_att'] = $sync_time;
		    		// print_r($save_data);die;
		    		$exit_teacher = $this->exits_teacher_att($value['u_id'],$exits_teacher);
		    		if($exit_teacher==true)
		    		{

		    		$result[] = $this->teacher_attendance_model->teachers_saveAtt('teach_attendance_live',$save_data);
		    		}else
		    		{
		    		$result[] = 0;

		    		}

		    	}
		    	$dataresult =  array_filter($result, function ($var) use ($filterBy) {
					    			return ($var == $filterBy);
							});
		    		if(!empty($dataresult))
		    		{
		    			$data['dataStatus'] = false;
                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                        $data['message'] = 'Already Attendance Marked In This School';
                        $this->response($data,REST_Controller::HTTP_OK);
		    		}else
		    		{
		    			$data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['message'] = 'Successfull Sync Teacher Attendance In This School';
                        $this->response($data,REST_Controller::HTTP_OK);
		    		}
	    		
	    	}else
	    	{

		    		$save_data['school_id'] = $school_id;
		    		$save_data['date'] = date('Y-m-d');
		    		$save_data['atturl'] = 'Mobile';
		    		$save_data['school_code'] = $school_code;
		    		$save_data['mark_att'] = $sync_time;
		    		$result = $this->teacher_attendance_model->teachers_saveAtt('teach_attendance_live',$save_data);

		    		// print_r($save_data);die;
		    		if($result ==0)
		    		{
		    			$data['dataStatus'] = false;
                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                        $data['message'] = 'Alreday Attendance Marked In This School';
                        $this->response($data,REST_Controller::HTTP_OK);
		    		}else
		    		{
		    			$data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['message'] = 'Successfull Sync Teacher Attendance In This School';
                        $this->response($data,REST_Controller::HTTP_OK);
		    		}
	    	}
    }


    public function exits_teacher_att($teacher_id='',$exits_teacher)
    {
    	

    	$exit_teacher_id = array_filter($exits_teacher,function($val) use($teacher_id)
    	{
    			return ($val->teacher_code==$teacher_id);
    	});

    	if(!empty($exit_teacher_id))
    	{
    		return false;
    	}else
    	{
    		return true;
    	}
    }

    public function marked_teacher_attendance_get()
    {
    	$school_id = $this->get('school_id');

    	$result = $this->teacher_attendance_model->marked_teacher_att_details('teach_attendance_live',date('Y-m-d'),$school_id);
    		if($result !='')
		    		{
		    			$data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_OK;
                        $data['records'] = $result;
                        $this->response($data,REST_Controller::HTTP_OK);
		    		}else
		    		{
		    			$data['dataStatus'] = true;
                        $data['status'] = REST_Controller::HTTP_NO_CONTENT;
                        $data['message'] = 'Not Marked In This School';
                        $this->response($data,REST_Controller::HTTP_OK);
		    		}
    }

}
 ?>