<?php
/**
 * Created by subline.
 * User: sriram
 * Date: 10/10/19
 */

defined('BASEPATH') OR exit('No direct script access allowed');

class School_Information_model extends CI_Model
{

	/**
	  * School Information Details 
	  * VIT-sriram
	  * 10/10/2019
	  * @parms school_id
	  */

    
    public function get_school_details($school_id)
    {
    	$this->db->select('school_id,district_id,district_name,block_id,block_name,school_name,				   udise_code,school_type,school_type_id,cate_type,management,						   section_nos,total_b,total_g,total_t,teach_tot,nonteach_tot');
    			 
    	$result = $this->db->get_where('students_school_child_count',array('school_id'=>$school_id))->first_row();

    	return $result;
    }

    /**
	  * Class Section Details From School
	  * VIT-sriram
	  * 10/10/2019
	  * parms school_id
      * Section Status 0 - not marked 1- sync local 2 - marked 
	  */

    public function get_school_section($school_id)
    {
        $date= date('Y-m-d');
    		$this->db->select('school_key_id,class_id,group_concat(section) as 								   section,school_type,st_class,group_concat(distinct st_section) as marked_section')
                     ->join('students_attend_daily b',"a.school_key_id = b.school_id and a.class_id = b.st_class and a.section = b.st_section and  b.date ='$date'",'left')
    				 ->group_by('a.class_id')
                     ->order_by('a.class_id','ASC');
    		$result = $this->db->get_where('schoolnew_section_group a',array('a.school_key_id'=>$school_id))->result();
                     
            $final_result = [];
            if(!empty($result))
            {
                // print_r($result);die;
                foreach($result as $index=> $res)
                {
                    
                    $sections = explode(",",$res->section);
                    // echo "class".$res->class_id;
                    sort($sections);
                    // print_r($sections);

                    if($res->marked_section !='')
                    {
                        // echo "if";
                        $marked_section = explode(",",$res->marked_section);
                        sort($marked_section);
                        // print_r($marked_section);
                    }else
                    {
                        $marked_section = [];
                    }
                    
                    $result[$index]->section = $sections;
                    
                    $final_result = [];
                    
                    foreach($sections as $sindex=> $sres)
                    {
                        // print_r($marked_section);die;
                        if(sizeof($marked_section) >0)
                        {
                            foreach($marked_section as $marked_sec)
                            {

                                if($sres==$marked_sec)
                                {
                                    // echo $marked_sec.'-'.$sres;

                                   $final_result[$sres] = "2";
                                   break;
                                }else
                                {
                                    $final_result[$sres] = "0";
                                }
                            }
                        }else
                        {
                            $final_result[$sres] = "0";
                        }

                        
                    } 
                //     // print_r($final_result);die;
                    $result[$index]->section_status = $final_result;
                 }

            }
    		return $result;
    }

    /**
	  * Class Section Based Students Details From School
	  * VIT-sriram
	  * 10/10/2019
	  * parms school_id
	  */
	public function get_school_student_data($school_id,$class_id='')
    {
    		$students_data = [];
            if($class_id !='')
            {

                    $this->db->select('unique_id_no,class_section,class_studying_id,name,name_tamil,id,gender,phone_number,school_id');
                    $this->db->order_by('name','ASC');
                        $students_data[$class_id]['class_details']  = $this->db->get_where('students_child_detail',array('school_id'=>$school_id,'transfer_flag'=>0,'class_studying_id'=>$class_id))->result();
                    //print_r($this->db->last_query());die();
            }else
            {
                $school_class_details = $this->get_school_section($school_id);
                // print_r($school_class_details);die;
        		if(!empty($school_class_details))
        		{
        			foreach($school_class_details as $sch_key=>$sch_cls_details)
        			{
                        // echo $sch_cls_details->class_id;die;
        				$this->db->select('unique_id_no,class_section,class_studying_id,name,name_tamil,id,gender,phone_number,school_id');
                        $this->db->order_by('gender','ASC');
                        $this->db->order_by('name','ASC');
    					$students_data[$sch_cls_details->class_id]['class_details']  = $this->db->get_where('students_child_detail',array('school_id'=>$school_id,'transfer_flag'=>0,'class_studying_id'=>$sch_cls_details->class_id))->result();
    					// print_r($this->db->last_query());die;
        			}
        		}
            }
    		return $students_data;

    	  		
    }


    /************************************ End *****************************************/

    /**
      * Class Section Based Students Details From School
      * VIT-sriram
      * 10/10/2019
      * parms school_id
      */

    public function get_schoolwise_teacher_list($school_id)
    {

            $date = date('Y-m-d');
          $this->db->select('b.teacher_name,b.teacher_code,gender,b.teacher_type,b.u_id,b.mbl_nmbr',false)
          ->from('udise_staffreg as b')
          ->where('b.school_key_id',$school_id)
          ->where('b.archive ',1)
          ->order_by('b.teacher_name','ASC');
          $result = $this->db->get()->result();
          // print_r($this->db->last_query());
          $final_result = [];
          if(!empty($result))
          {
                foreach ($result as $key => $value) {
                        $final_result[$key]               = $value;
                        $final_result[$key]->present      = '1';
                        $final_result[$key]->attres       = '';
                        $final_result[$key]->attstatus    = '';  
                        $final_result[$key]->id           = '';
                        $final_result[$key]->desgination  = '';
                }
          }
          return $final_result;

    }


    public function get_marked_teacher_records_status($school_id)
    {
            $date = date('Y-m-d');
       // $this->db2 = $this->load->database('tnschools_working',TRUE);
        $this->db->select('attres,attstatus,id');

        $result = $this->db->get_where('teach_attendance_live',array('school_id'=>$school_id,'date'=>$date))->num_rows();
        // echo $result;die;
        $result = ($result==0?$result:2);
        return $result;

    }


    /********************************** End ***********************************/

    /**
      * Mobile App Info
      * Sriram
      * 10/12/2019
      */

    public function mbl_app_info()
    {
        $result = $this->db->get_where('school_app_version_info',array('status'=>1))->first_row();
        return $result;
    }


    /*********************************** End ************************************/

    /*****************************Get Flash News *******************************/ 


    public function get_flash_news_data($school_id)
    {
      
      $this->db->select('district_name,block_name,school_type,school_type_id,cate_type');
      $result = $this->db->get_where('students_school_child_count',array('udise_code'=>$school_id))->first_row();
      
      $flash_result = [];
        if(!empty($result))
        {
          // print_r($this->session->userdata());
            $this->db->select('schoolnew_flashnews.*,user_category.user_type')
                     ->from('schoolnew_flashnews')
                     ->join('user_category','user_category.id = schoolnew_flashnews.created_type_id')
                     ->where('authority',1)
                     ->where('district_name',$result->district_name)
                     ->where('block_name',$result->block_name)
                     ->where('FIND_IN_SET("Government",school_type)!=',0)
                     
                     // ->where('FIND_IN_SET("'.$result->school_type.'",school_type)')
                     ->where('FIND_IN_SET("'.$result->cate_type.'",cate_type)!=',0)
                     ->group_by('updated_date')
                     ->order_by('schoolnew_flashnews.id DESC')
                     ->limit(10);
              $flash_result = $this->db->get()->result();
            // print_r($this->db->last_query());die;
              return $flash_result;
        }else
        {
          return $flash_result;
        }

    }

    public function voctnl_book_studntlist($school_id,$class_id='',$sec='')
    {
    		$students_data = [];
            if($class_id !='')
            {

                    // $this->db->select('unique_id_no,class_section,class_studying_id,name,name_tamil,id,gender,phone_number,school_id');
                    // $this->db->order_by('name','ASC');
                    // $students_data[$class_id]['class_details']  = $this->db->get_where('students_child_detail',array('school_id'=>$school_id,'transfer_flag'=>0,'class_studying_id'=>$class_id))->result();
                    $sql = "SELECT `unique_id_no`, `class_section`, `class_studying_id`, `name`, `name_tamil`, `id`, `gender`, `phone_number`,
                    `school_id`,`group_code_id`,`education_medium_id`
                    FROM `students_child_detail`
                    WHERE `school_id` = $school_id
                    AND `transfer_flag` =0
                    AND `class_studying_id` = $class_id
                    AND `class_section` = '$sec'
                    ORDER BY `name` ASC;";
                    $query = $this->db->query($sql);
                    //print_r($this->db->last_query());die();
                    $result = $query->result_array();
            }
    		return $result;

    	  		
    }

   





    	
}
?>